﻿using System;
using System.Runtime.CompilerServices;

public struct StructTest
{
    int key;
    public int Key { get { return key; } set { key = value; } }

    public override bool Equals(object obj)
    {
        return base.Equals(obj);
    }
}

class Program
{
    int key;
    public int Key { get { return key; } set { key = value; } }

    static void Main(string[] args)
    {
        bool test_program_equals = true;
        bool test_int_equals = true;

        if (test_program_equals == true)
        {
            Console.WriteLine("REF TYPE: Program");
            Program p1 = new Program { Key = 5 };
            Program p2 = new Program { Key = 5 };

            //object po1 = p1;
            //object po2 = p2;
            //object.ReferenceEquals(po1, po2);
            //bool result = po1 == po2;


            //Console.WriteLine("p1 == p2: " + (p1 == p2));

            Console.WriteLine("p1.Equals(p2): " + p1.Equals(p2));
            Console.WriteLine("object.ReferenceEquals(p1, p2): " + object.ReferenceEquals(p1, p2));
            Console.WriteLine("RuntimeHelpers.Equals(p1, p2): " + RuntimeHelpers.Equals(p1, p2));

            Console.WriteLine();

            Program p3 = p1;

            //Console.WriteLine("p1 == p3: " + (p1 == p3));

            Console.WriteLine("p1.Equals(p3): " + p1.Equals(p3));
            Console.WriteLine("object.ReferenceEquals(p1, p3): " + object.ReferenceEquals(p1, p3));
            Console.WriteLine("RuntimeHelpers.Equals(p1, p3): " + RuntimeHelpers.Equals(p1, p3));
        }

        Console.WriteLine();
        Console.WriteLine();

        if (test_int_equals == true)
        {
            //Console.WriteLine("VALUE TYPE: int");
            //int p1 = 5;
            //int p2 = 5;

            //Console.WriteLine("p1.Equals(p2): " + p1.Equals(p2));
            //Console.WriteLine("object.ReferenceEquals(p1, p2): " + object.ReferenceEquals(p1, p2));
            //Console.WriteLine("RuntimeHelpers.Equals(p1, p2): " + RuntimeHelpers.Equals(p1, p2));

            //Console.WriteLine();

            //int p3 = p1;

            //Console.WriteLine("p1.Equals(p3): " + p1.Equals(p3));
            //Console.WriteLine("object.ReferenceEquals(p1, p3): " + object.ReferenceEquals(p1, p3));
            //Console.WriteLine("RuntimeHelpers.Equals(p1, p3): " + RuntimeHelpers.Equals(p1, p3));

            Console.WriteLine();
            Console.WriteLine("5.Equals(5): " + 5.Equals(5));
            Console.WriteLine("object.ReferenceEquals(5, 5): " + object.ReferenceEquals(5, 5));
            Console.WriteLine("RuntimeHelpers.Equals(5, 5): " + RuntimeHelpers.Equals(5, 5));


            //int x = 1; int y = 1;

            //bool ret = RuntimeHelpers.Equals(x, y);

            //Console.WriteLine("The return value of RuntimeHelpers.Equals is: " + ret);
        }

        return;


        //StructTest t1 = new StructTest { Key = 5 };
        //StructTest t2 = new StructTest { Key = 5 };

        //result = RuntimeHelpers.Equals(t1, t2);
        //Console.WriteLine("RuntimeHelpers.Equals(t1, t2): " + result);

        //StructTest t3 = t1;
        //result = RuntimeHelpers.Equals(t1, t3);
        //Console.WriteLine("RuntimeHelpers.Equals(t1, t3): " + result);

        //// Operator '==' cannot be applied to operands of type 'StructTest' and 'StructTest'
        // Console.WriteLine(t1 == t2);
        //Console.WriteLine("t1.Equals(t2): " + t1.Equals(t2));
        //Console.WriteLine("object.ReferenceEquals(t1, t2): " + object.ReferenceEquals(t1, t2));

        //StructTest t3 = t1;

        //// Console.WriteLine(t1 == t3);
        //Console.WriteLine("t1.Equals(t3): " + t1.Equals(t3));
        //Console.WriteLine("object.ReferenceEquals(t1, t3): " + object.ReferenceEquals(t1, t3));
    }

    //public override int GetHashCode()
    //{
    //    return key;
    //}

    //public override bool Equals(object obj)
    //{
    //    Program p = obj as Program;

    //    if ((object)p == null)
    //    {
    //        return false;
    //    }

    //    return p.key == key;
    //}

    //public static bool operator ==(Program objA, Program objB)
    //{
    //    if (System.Object.ReferenceEquals(objA, objB))
    //    {
    //        return true;
    //    }

    //    if (((object)objA == null) || ((object)objB == null))
    //    {
    //        return false;
    //    }

    //    return objA.Equals(objB);
    //}

    //public static bool operator !=(Program objA, Program objB)
    //{
    //    return !(objA == objB);
    //}
}
